﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.Web.UI.NavigationControls;

public partial class _Default : System.Web.UI.Page
{
    int numUnchecked = 0;
    int numChecked = 0;
    int numPartChecked = 0;
    int totalNodes = 0;

    protected void Page_Load(object sender, EventArgs e)
    {

    }
    protected void Button1_Click(object sender, EventArgs e)
    {
        RecursiveCountNodes(WebDataTree1.Nodes);
    }

    private void RecursiveCountNodes(DataTreeNodeCollection nodes)
    {
        foreach (DataTreeNode node in nodes)
        {
            //  Get the state of each node.
            if (node.CheckState == Infragistics.Web.UI.CheckBoxState.Unchecked)
                ++numUnchecked;
            if (node.CheckState == Infragistics.Web.UI.CheckBoxState.Checked)
                ++numChecked;
            if (node.CheckState == Infragistics.Web.UI.CheckBoxState.Partial)
                ++numPartChecked;

            //  Increase the total node count.
            ++totalNodes;

            //  Check the children nodes for their state.
            if (node.Nodes.Count > 0)
                RecursiveCountNodes(node.Nodes);
        }
    }
}